- add applet taskset to set/retrieve the CPU affinity of a process
authorBernhard Reutner-Fischer <rep.dot.nop@gmail.com>
Wed, 7 Jun 2006 15:44:59 +0000 (15:44 -0000)
committerBernhard Reutner-Fischer <rep.dot.nop@gmail.com>
Wed, 7 Jun 2006 15:44:59 +0000 (15:44 -0000)
   text    data     bss     dec     hex filename
    584       0       0     584     248 taskset.o.gcc-2.95
    509       0       0     509     1fd taskset.o.gcc-3.3
    505       0       0     505     1f9 taskset.o.gcc-3.4
    506       0       0     506     1fa taskset.o.gcc-4.0
    498       0       0     498     1f2 taskset.o.gcc-4.1
    495       0       0     495     1ef taskset.o.gcc-4.2-HEAD

include/applets.h
include/usage.h
miscutils/Config.in
miscutils/Makefile.in
miscutils/taskset.c [new file with mode: 0644]
testsuite/taskset.tests [new file with mode: 0755]

index d020c5f..c9d5ac1 100644 (file)
@@ -262,6 +262,7 @@ USE_BB_SYSCTL(APPLET(sysctl, _BB_DIR_SBIN, _BB_SUID_NEVER))
 USE_SYSLOGD(APPLET(syslogd, _BB_DIR_SBIN, _BB_SUID_NEVER))
 USE_TAIL(APPLET(tail, _BB_DIR_USR_BIN, _BB_SUID_NEVER))
 USE_TAR(APPLET(tar, _BB_DIR_BIN, _BB_SUID_NEVER))
+USE_TASKSET(APPLET(taskset, _BB_DIR_USR_BIN, _BB_SUID_NEVER))
 USE_TEE(APPLET(tee, _BB_DIR_USR_BIN, _BB_SUID_NEVER))
 USE_TELNET(APPLET(telnet, _BB_DIR_USR_BIN, _BB_SUID_NEVER))
 USE_TELNETD(APPLET(telnetd, _BB_DIR_USR_SBIN, _BB_SUID_NEVER))
index 239bbb3..9bdfb3f 100644 (file)
@@ -2955,6 +2955,23 @@ USE_FEATURE_DATE_ISOFMT( \
        "$ zcat /tmp/tarball.tar.gz | tar -xf -\n" \
        "$ tar -cf /tmp/tarball.tar /usr/local\n"
 
+#define taskset_trivial_usage \
+       "[OPTIONS] [mask] [pid | command [arg]...]"
+#define taskset_full_usage \
+       "Set or get CPU affinity.\n\n" \
+       "Options:\n" \
+       "\t-p\toperate on an existing PID"
+#define taskset_example_usage \
+       "$ taskset 0x7 ./dgemm_test&\n" \
+       "$ taskset -p 0x1 $!\n" \
+       "pid 4790's current affinity mask: 7\n" \
+       "pid 4790's new affinity mask: 1\n" \
+       "$ taskset 0x7 /bin/sh -c './taskset -p 0x1 $$'\n" \
+       "pid 6671's current affinity mask: 1\n" \
+       "pid 6671's new affinity mask: 1\n" \
+       "$ taskset -p 1\n"
+       "pid 1's current affinity mask: 3\n"
+
 #define tee_trivial_usage \
        "[OPTION]... [FILE]..."
 #define tee_full_usage \
index fc90b54..37c1de8 100644 (file)
@@ -291,6 +291,12 @@ config CONFIG_SETSID
        help
          setsid runs a program in a new session
 
+config CONFIG_TASKSET
+       bool "taskset"
+       default n
+       help
+         Retrieve or set a processes's CPU affinity (on linux)
+
 config CONFIG_TIME
        bool "time"
        default n
index a0b6b72..d60d687 100644 (file)
@@ -28,6 +28,7 @@ MISCUTILS-$(CONFIG_RUNLEVEL)    += runlevel.o
 MISCUTILS-$(CONFIG_RX)          += rx.o
 MISCUTILS-$(CONFIG_SETSID)      += setsid.o
 MISCUTILS-$(CONFIG_STRINGS)     += strings.o
+MISCUTILS-$(CONFIG_TASKSET)     += taskset.o
 MISCUTILS-$(CONFIG_TIME)        += time.o
 MISCUTILS-$(CONFIG_WATCHDOG)    += watchdog.o
 
diff --git a/miscutils/taskset.c b/miscutils/taskset.c
new file mode 100644 (file)
index 0000000..a72f3ff
--- /dev/null
@@ -0,0 +1,67 @@
+/* vi: set sw=4 ts=4: */
+/*
+ * taskset - retrieve or set a processes's CPU affinity
+ * Copyright (c) 2006 Bernhard Fischer
+ *
+ * Licensed under GPLv2 or later, see file LICENSE in this tarball for details.
+ */
+
+#include "busybox.h"
+#include <sched.h>
+#include <unistd.h>
+#include <getopt.h> /* optind */
+
+int taskset_main(int argc, char** argv)
+{
+       cpu_set_t mask, new_mask;
+       pid_t pid = 0;
+       unsigned long ul;
+       const char *state = "current\0new";
+       char *p_opt = NULL, *aff = NULL;
+
+       ul = bb_getopt_ulflags(argc, argv, "+p:", &p_opt);
+#define TASKSET_OPT_p (1)
+
+       if (ul & TASKSET_OPT_p) {
+               if (argc == optind+1) { /* -p <aff> <pid> */
+                       aff = p_opt;
+                       p_opt = argv[optind];
+               }
+               argv += optind; /* me -p <arg> */
+               pid = bb_xgetularg10_bnd(p_opt, 1, ULONG_MAX); /* -p <pid> */
+       } else
+               aff = *++argv; /* <aff> <cmd...> */
+       if (aff) {
+/*             to_cpuset(bb_xgetularg_bnd(aff, 16, 1, ULONG_MAX), &new_mask); */
+               unsigned i = 0;
+               unsigned long l = bb_xgetularg_bnd(aff, 16, 1, ULONG_MAX);
+
+               CPU_ZERO(&new_mask);
+               while (i < CPU_SETSIZE && l >= (1<<i)) {
+                       if ((1<<i) & l)
+                               CPU_SET(i, &new_mask);
+                       ++i;
+               }
+       }
+
+       if (ul & TASKSET_OPT_p) {
+print_aff:
+               if (sched_getaffinity(pid, sizeof (mask), &mask) < 0)
+                       bb_perror_msg_and_die("Failed to %cet pid %d's affinity", 'g', pid);
+               bb_printf("pid %d's %s affinity mask: %x\n", /* %x .. perhaps _FANCY */
+                               pid, state, mask);
+               if (!*argv) /* no new affinity given or we did print already, done. */
+                       return EXIT_SUCCESS;
+       }
+
+       if (sched_setaffinity(pid, sizeof (new_mask), &new_mask))
+               bb_perror_msg_and_die("Failed to %cet pid %d's affinity", 's', pid);
+       if (ul & TASKSET_OPT_p) {
+               state += 8;
+               ++argv;
+               goto print_aff;
+       }
+       ++argv;
+       execvp(*argv, argv);
+       bb_perror_msg_and_die("%s", *argv);
+}
diff --git a/testsuite/taskset.tests b/testsuite/taskset.tests
new file mode 100755 (executable)
index 0000000..6001c3e
--- /dev/null
@@ -0,0 +1,17 @@
+#!/bin/sh
+
+# Copyright 2006 Bernhard Fischer
+# Licensed under GPL v2 or later, see file LICENSE for details.
+
+. testing.sh
+a="taskset"
+
+# testing "test name"              "opts" "expected result" "file inp" "stdin"
+testing "taskset (get from pid 1)" "$a -p1 >/dev/null;echo \$?" "0\n" "" ""
+testing "taskset (invalid pid)"    "$a -p0 >/dev/null 2>&1;echo \$?" "1\n" "" ""
+testing "taskset (set_aff, needs CAP_SYS_NICE)" \
+                                   "$a 0x1 $SHELL -c $a\ -p\ \$$\|grep\ \"current\ affinity\ mask:\ 1\" >/dev/null;echo \$?" \
+                                                               "0\n" "" ""
+
+unset a
+exit $FAILCOUNT